import dds
import ddsutil
import geometry_msgs/msg/Vector3_.geometry_msgs.msg.dds_
import std_msgs/msg/Header_.std_msgs.msg.dds_
import struct

class MagneticField___TypeSupport(dds.TypeSupport):

    _typename = 'sensor_msgs::msg::dds_::MagneticField_'
    _keylist = ''
    _metadescriptor = '<MetaData version="1.0.0"><Module name="geometry_msgs"><Module name="msg"><Module name="dds_"><Struct name="Vector3_"><Member name="x_"><Double/></Member><Member name="y_"><Double/></Member><Member name="z_"><Double/></Member></Struct></Module></Module></Module><Module name="builtin_interfaces"><Module name="msg"><Module name="dds_"><Struct name="Time_"><Member name="sec_"><Long/></Member><Member name="nanosec_"><ULong/></Member></Struct></Module></Module></Module><Module name="std_msgs"><Module name="msg"><Module name="dds_"><Struct name="Header_"><Member name="stamp_"><Type name="::builtin_interfaces::msg::dds_::Time_"/></Member><Member name="frame_id_"><String/></Member></Struct></Module></Module></Module><Module name="sensor_msgs"><Module name="msg"><Module name="dds_"><Struct name="MagneticField_"><Member name="header_"><Type name="::std_msgs::msg::dds_::Header_"/></Member><Member name="magnetic_field_"><Type name="::geometry_msgs::msg::dds_::Vector3_"/></Member><Member name="magnetic_field_covariance_"><Array size="9"><Double/></Array></Member></Struct></Module></Module></Module></MetaData>'

    def __init__(self):
        super(MagneticField___TypeSupport, self).__init__(self._typename,
              self._keylist,
              self._metadescriptor,
              struct.calcsize(MagneticField_()._get_packing_fmt()))

    def _serialize(self, o):
        if not isinstance(o, MagneticField_):
            raise TypeError('Incorrect data type')
        result = o._serialize()
        return result

    def _deserialize(self, buf):
        result = MagneticField_()
        data = struct.unpack(result._get_packing_fmt(), buf)
        result._deserialize(list(data))
        return result

class MagneticField_(ddsutil.TopicDataClass):

    @staticmethod
    def get_type_support():
        ''' Return type support information required for dds.Topic constructor '''
        return MagneticField___TypeSupport()

    @property
    def header_(self):
        '''
        a DDS std_msgs::msg::dds_::Header_ value
        @rtype: std_msgs/msg/Header_.std_msgs.msg.dds_.Header_
        '''
        return self._header__

    _header__checker = ddsutil._class_checker(std_msgs/msg/Header_.std_msgs.msg.dds_.Header_)
    @header_.setter
    def header_(self, value):
        self._header__checker(value)
        self._header__ = value

    @property
    def magnetic_field_(self):
        '''
        a DDS geometry_msgs::msg::dds_::Vector3_ value
        @rtype: geometry_msgs/msg/Vector3_.geometry_msgs.msg.dds_.Vector3_
        '''
        return self._magnetic_field__

    _magnetic_field__checker = ddsutil._class_checker(geometry_msgs/msg/Vector3_.geometry_msgs.msg.dds_.Vector3_)
    @magnetic_field_.setter
    def magnetic_field_(self, value):
        self._magnetic_field__checker(value)
        self._magnetic_field__ = value

    @property
    def magnetic_field_covariance_(self):
        '''
        a DDS double[9] value
        @rtype: list
        '''
        return self._magnetic_field_covariance__

    _magnetic_field_covariance__checker = ddsutil._array_checker(9,ddsutil._float_checker)
    @magnetic_field_covariance_.setter
    def magnetic_field_covariance_(self, value):
        self._magnetic_field_covariance__checker(value)
        self._magnetic_field_covariance__ = value

    _member_attributes = ('header_', 'magnetic_field_', 'magnetic_field_covariance_')

    def __init__(self, **kwargs):
        ''' Create a MagneticField_ instance, optionally initializing fields by name '''
        # init attributes to default value
        self.header_ = std_msgs/msg/Header_.std_msgs.msg.dds_.Header_()
        self.magnetic_field_ = geometry_msgs/msg/Vector3_.geometry_msgs.msg.dds_.Vector3_()
        self.magnetic_field_covariance_ = [0.0 for _ in range(9)]
        # set values for attributes passed in
        for key, value in kwargs.items():
            if key not in self._member_attributes:
                raise TypeError('Invalid argument name : %s' %(key))
            setattr(self, key, value)

    _packing_fmt = None

    @staticmethod
    def _get_packing_fmt():
        ''' Returns packing format of this class data '''
        if MagneticField_._packing_fmt is not None:
            return MagneticField_._packing_fmt
        fmt = ''
        fmt += ddsutil._align(fmt, std_msgs/msg/Header_.std_msgs.msg.dds_.Header_._get_packing_fmt())
        fmt += ddsutil._align(fmt, geometry_msgs/msg/Vector3_.geometry_msgs.msg.dds_.Vector3_._get_packing_fmt())
        fmt += 'd' * 9

        MagneticField_._packing_fmt = ddsutil._pad_fmt(fmt)
        return MagneticField_._packing_fmt

    def _serialize(self):
        ''' Serialize data for writing '''
        fmt = self._get_packing_fmt()
        args = self._get_packing_args()
        result = struct.pack(fmt, *args)
        return result

    def _deserialize(self, data):
        ''' Initialize values from data returned by struct.unpack()'''
        self.header_ = std_msgs/msg/Header_.std_msgs.msg.dds_.Header_()._deserialize(data)
        self.magnetic_field_ = geometry_msgs/msg/Vector3_.geometry_msgs.msg.dds_.Vector3_()._deserialize(data)
        self.magnetic_field_covariance_ = [data.pop(0) for _ in range (9)]
        return self;

    def _get_packing_args(self):
        ''' Return an list of data suitable for struct.pack '''
        args = []
        args.extend(self.header_._get_packing_args())
        args.extend(self.magnetic_field_._get_packing_args())
        ddsutil._lin_map_array(self.magnetic_field_covariance_, 1, lambda v: args.append(v))
        return args

